GNU bug report logs - #58557
29.0.50; elisp-completion-at-point don't complete local variables when using setq

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Disroot <hilde.rhyne@HIDDEN>; merged with #58148, #58396; dated Sun, 16 Oct 2022 00:56:03 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.
Forcibly Merged 58148 58396 58557. Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 58557 <at> debbugs.gnu.org:


Received: (at 58557) by debbugs.gnu.org; 16 Oct 2022 09:23:26 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 16 05:23:26 2022
Received: from localhost ([127.0.0.1]:43370 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ojzri-0006nR-41
	for submit <at> debbugs.gnu.org; Sun, 16 Oct 2022 05:23:26 -0400
Received: from quimby.gnus.org ([95.216.78.240]:42140)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1ojzrd-0006n6-7o
 for 58557 <at> debbugs.gnu.org; Sun, 16 Oct 2022 05:23:24 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:Date:References:
 In-Reply-To:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=oFceCGhuZlPAB1iK96ZL+jyvAe8q5+6CIiCrn6OPh3w=; b=lVXZ9NmcAD472JFYnbrARhG1Ws
 16F6/UHtRR7qdz9WkE9mYdKJjsVW9eFD7uJpd/TVKepmy1WlrGLRvQIrHnrC8QwzZWaQINw6tYpaW
 /icLRlEkJSHiXvGBbPSb999CGg4ZVw3O/yf93fHOvKWDzNtzvAmo0CfmNY0mdngBfshw=;
Received: from [84.212.220.105] (helo=downe)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1ojzrV-0004VT-6Y; Sun, 16 Oct 2022 11:23:15 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Disroot <hilde.rhyne@HIDDEN>
Subject: Re: bug#58557: 29.0.50; elisp-completion-at-point don't complete
 local variables when using setq
In-Reply-To: <06E597B1-1194-49F6-91EF-DF736ED4AA75@HIDDEN> (Disroot's
 message of "Sun, 16 Oct 2022 01:25:28 +0800")
References: <06E597B1-1194-49F6-91EF-DF736ED4AA75@HIDDEN>
X-Now-Playing: Tracey Thorn's _Out Of The Woods_: "A-Z"
Date: Sun, 16 Oct 2022 11:23:12 +0200
Message-ID: <87v8okyven.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Disroot <hilde.rhyne@HIDDEN> writes: > Return value in
 Emacs 29.0.50: > > (signal 'wrong-number-of-arguments > '(setq 1)) > > I
 also tested those two steps on Emacs 28.2, released version > with emacs -Q,
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 58557
Cc: 58557 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Disroot <hilde.rhyne@HIDDEN> writes:

> Return value in Emacs 29.0.50: 
>
> (signal 'wrong-number-of-arguments
>         '(setq 1))
>
> I also tested those two steps on Emacs 28.2, released version 
> with emacs -Q,

Ah, this looks like another symptom of bug#58396 and bug#58148, so I've
merged these bugs.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#58557; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 16 Oct 2022 00:56:01 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Oct 15 20:56:01 2022
Received: from localhost ([127.0.0.1]:42830 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ojrwe-0005aN-9l
	for submit <at> debbugs.gnu.org; Sat, 15 Oct 2022 20:56:00 -0400
Received: from lists.gnu.org ([209.51.188.17]:36256)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <hilde.rhyne@HIDDEN>) id 1ojkus-0007aW-8j
 for submit <at> debbugs.gnu.org; Sat, 15 Oct 2022 13:25:42 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:36874)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <hilde.rhyne@HIDDEN>)
 id 1ojkus-0003Hm-0x
 for bug-gnu-emacs@HIDDEN; Sat, 15 Oct 2022 13:25:42 -0400
Received: from knopi.disroot.org ([178.21.23.139]:43178)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <hilde.rhyne@HIDDEN>)
 id 1ojkuq-0004xt-12
 for bug-gnu-emacs@HIDDEN; Sat, 15 Oct 2022 13:25:41 -0400
Received: from localhost (localhost [127.0.0.1])
 by disroot.org (Postfix) with ESMTP id 8ECD64DA66
 for <bug-gnu-emacs@HIDDEN>; Sat, 15 Oct 2022 19:25:35 +0200 (CEST)
X-Virus-Scanned: SPAM Filter at disroot.org
Received: from knopi.disroot.org ([127.0.0.1])
 by localhost (disroot.org [127.0.0.1]) (amavisd-new, port 10024)
 with ESMTP id 2zZiVAZs1b32 for <bug-gnu-emacs@HIDDEN>;
 Sat, 15 Oct 2022 19:25:34 +0200 (CEST)
From: Disroot <hilde.rhyne@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=disroot.org; s=mail;
 t=1665854733; bh=PG/iFN3+CqlIrSoEWGTOv5rkfkio2wICgqEsLLsts+c=;
 h=From:Subject:Date:To;
 b=RSb5hcY2eYu84kB1vHbMG2CTGp3B3k4z/1Rp8kW9ng95VhenC9n9nY69oZnQ3FRyu
 alKzWSACSLktwipD4kpzsBbeRVFozELsFePJo5p5/H5mXepahVsWvcnXsKop7/8fZ0
 P8BSLqyIlPFPrj8hqAoMecAeTQwfyugjNR8//qf9KLg2N9m1dxcX6lGUzKkVinpL93
 Z6tY90Yba5jJjBDk2OoQrUGGhTEQNMMXpOk8Xg6VDWnAB22X+KyO0Y+GMD9L7Ziy+W
 zCZ9oKb0bEgZlHqyIIB3nYZCoJ+XAVKXXoSjyk+57xfmswnM3XxA55hPIL51+nzdyx
 bb5iNkdW9ia/Q==
Content-Type: text/plain;
	charset=utf-8
Content-Transfer-Encoding: quoted-printable
Mime-Version: 1.0
Subject: 29.0.50; elisp-completion-at-point don't complete local variables
 when using setq
Message-Id: <06E597B1-1194-49F6-91EF-DF736ED4AA75@HIDDEN>
Date: Sun, 16 Oct 2022 01:25:28 +0800
To: bug-gnu-emacs@HIDDEN
Received-SPF: pass client-ip=178.21.23.139;
 envelope-from=hilde.rhyne@HIDDEN; helo=knopi.disroot.org
X-Spam_score_int: -20
X-Spam_score: -2.1
X-Spam_bar: --
X-Spam_report: (-2.1 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: submit
X-Mailman-Approved-At: Sat, 15 Oct 2022 20:55:52 -0400
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.4 (--)

elisp-completion-at-point will not complete local variables when using =
setq.

Tested with emacs -Q, latest Emacs master

Steps to Reproduce:

Snippet a:
(let (foo foo-foo bar bar-bar)
  (setq foo))
               ^

^ marked cursor position.

When pressing C-M-i (completion-at-point), no local variable completion =
will be provided.

And I found out it was related with elisp--local-variables and =
macroexpand-all:


Debug snippet:

Snippet b:

(let ((macroexpand-advice (lambda (expander form &rest args)
                            (condition-case nil
                                (apply expander form args)
                              (error form)
                              ))))
  (unwind-protect
      (progn
        (advice-add 'macroexpand :around macroexpand-advice)
        (macroexpand-all
         '(setq elisp--witness--lisp)))
    (advice-remove 'macroexpand macroexpand-advice)))

Return value in Emacs 29.0.50:=20

(signal 'wrong-number-of-arguments
        '(setq 1))


I also tested those two steps on Emacs 28.2, released version=20
with emacs -Q,

and with following system-configuration-features:
"ACL GMP GNUTLS JSON LIBXML2 MODULES NOTIFY=20
KQUEUE NS PDUMPER THREADS TOOLKIT_SCROLL_BARS ZLIB=E2=80=9D

completion-at-point worked normally in Snippet a.

Return value of Snippet b is:

(setq elisp--witness--lisp)
=
=E2=80=94=E2=80=94=E2=80=94=E2=80=94=E2=80=94=E2=80=94=E2=80=94=E2=80=94=E2=
=80=94=E2=80=94=E2=80=94=E2=80=94=E2=80=94=E2=80=94=E2=80=94=E2=80=94=E2=80=
=94=E2=80=94=E2=80=94=E2=80=94=E2=80=94=E2=80=94=E2=80=94=E2=80=94=E2=80=94=
=E2=80=94=E2=80=94=E2=80=94=E2=80=94=E2=80=94=E2=80=94=E2=80=94=E2=80=94=E2=
=80=94=E2=80=94=E2=80=94=E2=80=94=E2=80=94=E2=80=94=E2=80=94=E2=80=94=E2=80=
=94=E2=80=94=20
In GNU Emacs 29.0.50 (build 1, x86_64-apple-darwin21.6.0, NS
appkit-2113.60 Version 12.6 (Build 21G115)) of 2022-10-15 built on
MacBook-Pro-4.local
Repository revision: 9fcd59a97820e5154e678be8b98fe0cac4e4546e
Repository branch: HEAD
Windowing system distributor 'Apple', version 10.3.2113
System Description:  macOS 12.6

Configured using:
'configure --prefix=3D/opt/local --disable-silent-rules --without-dbus
--without-gconf --without-libotf --without-m17n-flt --with-libgmp
--with-gnutls --with-json --with-xml2 --with-modules --infodir
/opt/local/share/info/my-emacs --with-sqlite3 --with-webp --with-ns
--with-lcms2 --without-harfbuzz --without-imagemagick --without-xaw3d
--with-rsvg --with-xwidgets --with-native-compilation 'CFLAGS=3D-pipe =
-Os
-isysroot/Library/Developer/CommandLineTools/SDKs/MacOSX12.sdk -arch
x86_64' 'CPPFLAGS=3D-I/opt/local/include
-isysroot/Library/Developer/CommandLineTools/SDKs/MacOSX12.sdk'
'LDFLAGS=3D-L/opt/local/lib -Wl,-headerpad_max_install_names -Wl,-rpath
/opt/local/lib/gcc12 -Wl,-no_pie
-Wl,-syslibroot,/Library/Developer/CommandLineTools/SDKs/MacOSX12.sdk
-arch x86_64''

Configured features:
ACL GIF GLIB GMP GNUTLS JPEG JSON LCMS2 LIBXML2 MODULES NATIVE_COMP
NOTIFY KQUEUE NS PDUMPER PNG RSVG SQLITE3 THREADS TIFF
TOOLKIT_SCROLL_BARS WEBP XIM XWIDGETS ZLIB

Important settings:
  value of $LC_ALL: en_US.UTF-8
  value of $LC_CTYPE: UTF-8
  value of $LANG: en_US.UTF-8
  locale-coding-system: utf-8-unix

Major mode: Lisp Interaction

Minor modes in effect:
  tooltip-mode: t
  global-eldoc-mode: t
  eldoc-mode: t
  show-paren-mode: t
  electric-indent-mode: t
  mouse-wheel-mode: t
  tool-bar-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  blink-cursor-mode: t
  line-number-mode: t
  indent-tabs-mode: t
  transient-mark-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t

Load-path shadows:
None found.

Features:
(shadow sort mail-extr emacsbug message mailcap yank-media puny dired
dired-loaddefs rfc822 mml mml-sec password-cache epa derived epg rfc6068
epg-config gnus-util text-property-search time-date mm-decode mm-bodies
mm-encode mail-parse rfc2231 mailabbrev gmm-utils mailheader cl-loaddefs
comp comp-cstr warnings icons subr-x rx cl-seq cl-macs gv cl-extra
help-mode bytecomp byte-compile cconv cl-lib sendmail rfc2047 rfc2045
ietf-drums mm-util mail-prsvr mail-utils rmc iso-transl tooltip eldoc
paren electric uniquify ediff-hook vc-hooks lisp-float-type elisp-mode
mwheel term/ns-win ns-win ucs-normalize mule-util term/common-win
tool-bar dnd fontset image regexp-opt fringe tabulated-list replace
newcomment text-mode lisp-mode prog-mode register page tab-bar menu-bar
rfn-eshadow isearch easymenu timer select scroll-bar mouse jit-lock
font-lock syntax font-core term/tty-colors frame minibuffer nadvice seq
simple cl-generic indonesian philippine cham georgian utf-8-lang
misc-lang vietnamese tibetan thai tai-viet lao korean japanese eucjp-ms
cp51932 hebrew greek romanian slovak czech european ethiopic indian
cyrillic chinese composite emoji-zwj charscript charprop case-table
epa-hook jka-cmpr-hook help abbrev obarray oclosure cl-preloaded button
loaddefs faces cus-face macroexp files window text-properties overlay
sha1 md5 base64 format env code-pages mule custom widget keymap
hashtable-print-readable backquote threads xwidget-internal kqueue cocoa
ns lcms2 multi-tty make-network-process native-compile emacs)

Memory information:
((conses 16 78018 5659)
(symbols 48 7047 0)
(strings 32 19585 2332)
(string-bytes 1 603284)
(vectors 16 16757)
(vector-slots 8 335119 11861)
(floats 8 27 30)
(intervals 56 268 0)
(buffers 1000 11))




Acknowledgement sent to Disroot <hilde.rhyne@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#58557; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Sun, 16 Oct 2022 09:30:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.